# coding=utf-8
# *** WARNING: this file was generated by the Pulumi Terraform Bridge (tfgen) Tool. ***
# *** Do not edit by hand unless you're certain you know what you are doing! ***

import copy
import warnings
import sys
import pulumi
import pulumi.runtime
from typing import Any, Mapping, Optional, Sequence, Union, overload
if sys.version_info >= (3, 11):
    from typing import NotRequired, TypedDict, TypeAlias
else:
    from typing_extensions import NotRequired, TypedDict, TypeAlias
from . import _utilities
from . import outputs

__all__ = [
    'GetIdentityAliasResult',
    'AwaitableGetIdentityAliasResult',
    'get_identity_alias',
    'get_identity_alias_output',
]

@pulumi.output_type
class GetIdentityAliasResult:
    """
    A collection of values returned by getIdentityAlias.
    """
    def __init__(__self__, account_id=None, id=None, identity_aliases=None, identity_set_id=None, ids=None, username=None):
        if account_id and not isinstance(account_id, str):
            raise TypeError("Expected argument 'account_id' to be a str")
        pulumi.set(__self__, "account_id", account_id)
        if id and not isinstance(id, str):
            raise TypeError("Expected argument 'id' to be a str")
        pulumi.set(__self__, "id", id)
        if identity_aliases and not isinstance(identity_aliases, list):
            raise TypeError("Expected argument 'identity_aliases' to be a list")
        pulumi.set(__self__, "identity_aliases", identity_aliases)
        if identity_set_id and not isinstance(identity_set_id, str):
            raise TypeError("Expected argument 'identity_set_id' to be a str")
        pulumi.set(__self__, "identity_set_id", identity_set_id)
        if ids and not isinstance(ids, list):
            raise TypeError("Expected argument 'ids' to be a list")
        pulumi.set(__self__, "ids", ids)
        if username and not isinstance(username, str):
            raise TypeError("Expected argument 'username' to be a str")
        pulumi.set(__self__, "username", username)

    @property
    @pulumi.getter(name="accountId")
    def account_id(self) -> Optional[str]:
        """
        The account for this identity alias.
        """
        return pulumi.get(self, "account_id")

    @property
    @pulumi.getter
    def id(self) -> Optional[str]:
        """
        Unique identifier of the IdentityAlias.
        """
        return pulumi.get(self, "id")

    @property
    @pulumi.getter(name="identityAliases")
    def identity_aliases(self) -> Sequence['outputs.GetIdentityAliasIdentityAliasResult']:
        """
        A list where each element has the following attributes:
        """
        return pulumi.get(self, "identity_aliases")

    @property
    @pulumi.getter(name="identitySetId")
    def identity_set_id(self) -> Optional[str]:
        """
        The identity set.
        """
        return pulumi.get(self, "identity_set_id")

    @property
    @pulumi.getter
    def ids(self) -> Sequence[str]:
        """
        a list of strings of ids of data sources that match the given arguments.
        """
        return pulumi.get(self, "ids")

    @property
    @pulumi.getter
    def username(self) -> Optional[str]:
        """
        The username to be used as the identity alias for this account.
        """
        return pulumi.get(self, "username")


class AwaitableGetIdentityAliasResult(GetIdentityAliasResult):
    # pylint: disable=using-constant-test
    def __await__(self):
        if False:
            yield self
        return GetIdentityAliasResult(
            account_id=self.account_id,
            id=self.id,
            identity_aliases=self.identity_aliases,
            identity_set_id=self.identity_set_id,
            ids=self.ids,
            username=self.username)


def get_identity_alias(account_id: Optional[str] = None,
                       id: Optional[str] = None,
                       identity_set_id: Optional[str] = None,
                       username: Optional[str] = None,
                       opts: Optional[pulumi.InvokeOptions] = None) -> AwaitableGetIdentityAliasResult:
    """
    IdentityAliases define the username to be used for a specific account
     when connecting to a remote resource using that identity set.
    ## Example Usage

    ```python
    import pulumi
    import pulumi_sdm as sdm

    user = sdm.get_identity_alias(id="i-0900909",
        username="user")
    ```


    :param str account_id: The account for this identity alias.
    :param str id: Unique identifier of the IdentityAlias.
    :param str identity_set_id: The identity set.
    :param str username: The username to be used as the identity alias for this account.
    """
    __args__ = dict()
    __args__['accountId'] = account_id
    __args__['id'] = id
    __args__['identitySetId'] = identity_set_id
    __args__['username'] = username
    opts = pulumi.InvokeOptions.merge(_utilities.get_invoke_opts_defaults(), opts)
    __ret__ = pulumi.runtime.invoke('sdm:index/getIdentityAlias:getIdentityAlias', __args__, opts=opts, typ=GetIdentityAliasResult).value

    return AwaitableGetIdentityAliasResult(
        account_id=pulumi.get(__ret__, 'account_id'),
        id=pulumi.get(__ret__, 'id'),
        identity_aliases=pulumi.get(__ret__, 'identity_aliases'),
        identity_set_id=pulumi.get(__ret__, 'identity_set_id'),
        ids=pulumi.get(__ret__, 'ids'),
        username=pulumi.get(__ret__, 'username'))
def get_identity_alias_output(account_id: Optional[pulumi.Input[Optional[str]]] = None,
                              id: Optional[pulumi.Input[Optional[str]]] = None,
                              identity_set_id: Optional[pulumi.Input[Optional[str]]] = None,
                              username: Optional[pulumi.Input[Optional[str]]] = None,
                              opts: Optional[Union[pulumi.InvokeOptions, pulumi.InvokeOutputOptions]] = None) -> pulumi.Output[GetIdentityAliasResult]:
    """
    IdentityAliases define the username to be used for a specific account
     when connecting to a remote resource using that identity set.
    ## Example Usage

    ```python
    import pulumi
    import pulumi_sdm as sdm

    user = sdm.get_identity_alias(id="i-0900909",
        username="user")
    ```


    :param str account_id: The account for this identity alias.
    :param str id: Unique identifier of the IdentityAlias.
    :param str identity_set_id: The identity set.
    :param str username: The username to be used as the identity alias for this account.
    """
    __args__ = dict()
    __args__['accountId'] = account_id
    __args__['id'] = id
    __args__['identitySetId'] = identity_set_id
    __args__['username'] = username
    opts = pulumi.InvokeOutputOptions.merge(_utilities.get_invoke_opts_defaults(), opts)
    __ret__ = pulumi.runtime.invoke_output('sdm:index/getIdentityAlias:getIdentityAlias', __args__, opts=opts, typ=GetIdentityAliasResult)
    return __ret__.apply(lambda __response__: GetIdentityAliasResult(
        account_id=pulumi.get(__response__, 'account_id'),
        id=pulumi.get(__response__, 'id'),
        identity_aliases=pulumi.get(__response__, 'identity_aliases'),
        identity_set_id=pulumi.get(__response__, 'identity_set_id'),
        ids=pulumi.get(__response__, 'ids'),
        username=pulumi.get(__response__, 'username')))
